function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var Highlighter = _interopDefault(require('react-highlight-words'));

var shouldPierce = function shouldPierce(child) {
  return React.isValidElement(child) && typeof child.type === 'function' && child.type.name === 'Pierce';
};

var Search = function Search(_ref) {
  var children = _ref.children,
      onDone = _ref.onDone,
      test = _ref.test,
      value = _ref.value,
      highlighterProps = _ref.highlighterProps,
      _ref$highlightTag = _ref.highlightTag,
      highlightTag = _ref$highlightTag === void 0 ? 'mark' : _ref$highlightTag;
  var count = 0;

  var counterTag = function counterTag(_ref2) {
    var children = _ref2.children;
    count++;
    return React.createElement(highlightTag, null, children);
  };

  var Highlight = function Highlight(_ref3) {
    var child = _ref3.child;
    return React__default.createElement(Highlighter, Object.assign({}, highlighterProps, {
      searchWords: [value],
      textToHighlight: child,
      highlightTag: counterTag
    }));
  };

  var deepHighlight = function deepHighlight(child) {
    if (test && typeof child === 'string') {
      return React__default.createElement("mark", {
        key: child
      }, child);
    }

    if (typeof child === 'string') {
      return React__default.createElement(Highlight, {
        child: child
      });
    }

    if (shouldPierce(child)) {
      var piercedChildren = child.props.children;

      var pierceChildren = function pierceChildren(innerChild) {
        var prototype = innerChild.type.prototype;

        if (prototype && prototype.isReactComponent) {
          return new innerChild.type(innerChild.props).render();
        } else {
          return innerChild.type(innerChild.props);
        }
      };

      return deepHighlight(React.Children.map(piercedChildren, pierceChildren));
    }

    if (React.isValidElement(child)) {
      var props = child.props;

      var _children = deepHighlight(props.children);

      return React.cloneElement(child, props, _children);
    }

    if (Array.isArray(child)) {
      return React.Children.map(child, deepHighlight);
    }
  };

  React.useEffect(function () {
    onDone && onDone({
      count: count
    });
  });
  return deepHighlight(children) || null;
};

var Pierce = function Pierce(_ref4) {
  var children = _ref4.children;
  return children;
};

exports.Pierce = Pierce;
exports.default = Search;
//# sourceMappingURL=index.js.map
